; Petter Schau 1996
; Global constants and external variables defined in ac.c

;CYCLE_EXACT equ 1

USE_ASM equ 1

; Will remember the last 512000 instructions
; and enable event logging.
;DEBUGBUILD equ 1

; Will enable M68k prefetch emulation
;PREFETCH equ 1

;TSC_PROFILING equ 1

CHIPMEM equ 0200000h
FASTMEM equ 0800000h
BOGOMEM equ 01c0000h
KICKMEM equ 0080000h


CYCLESPERLINE equ 228
CYCLESPERFRAME equ 71364
LINESPERFRAME equ 313


TSC_BEFORE macro TMPVARIABLE
local   xxx
#ifdef TSC_PROFILING
                test    dword ptr [_tsc_profile],1
                jz      xxx
                push    eax
                push    edx
                push    ecx
                mov     ecx,10h
                rdtsc
                pop     ecx
                mov     dword ptr [TMPVARIABLE],eax
                mov     dword ptr [TMPVARIABLE+4],edx
                pop     edx
                pop     eax
#endif
xxx:
endm

TSC_AFTER macro TMPVARIABLE, VARIABLE, TIMES
local   xxx
#ifdef TSC_PROFILING
                test    dword ptr [_tsc_profile],1
                jz      xxx
                push    eax
                push    edx
                push    ecx
                mov     ecx,10h
                rdtsc
                pop     ecx
                sub     eax,dword ptr [TMPVARIABLE]
                sbb     edx,dword ptr [TMPVARIABLE+4]
                add     dword ptr [VARIABLE],eax
                adc     dword ptr [VARIABLE+4],edx
                inc     dword ptr [TIMES]
                pop     edx
                pop     eax
#endif
xxx:
endm

